<!DOCTYPE html>
<html>
    <head>
        <meta charset="UTF-8">
        <title>Ejercicio de programación</title>
        <link rel="stylesheet" href="https://fonts.googleapis.com/css?family=Roboto" type="text/css">
        <style>
            body { font-family: 'Roboto', serif; }
            .description { font-weight: 700; }
        </style>
        </head>
    <body>
        <h2>Trace IP</h2>
        <form id="form">
            <label>IP </label>
            <input type="text" name="ip" id="ip-input" autofocus required pattern="((^|\.)((25[0-5])|(2[0-4]\d)|(1\d\d)|([1-9]?\d))){4}$" />
            <input type="submit" name="submit" id="search-button" value="Buscar" />
        </form>
        <div id="results"></div>
        <hr />
        <div id="stats"></div>
        <script src="https://cdnjs.cloudflare.com/ajax/libs/jquery/3.4.1/jquery.min.js"></script>
        <script>
            $("#ip-input").keyup(function(event) {
                if (event.keyCode === 13) {
                    $("#search-button").click();
                }
            });

            $("#search-button").click(function() {
                if($("#form")[0].checkValidity()) {
                    
                    $.ajax({
                        url: "http://localhost:5001/app/get/" + $("#ip-input").val(),
                        contentType: "application/json",
                        dataType: 'json',
                        success: function(result){
                            showResult(result);
                            $.ajax({
                                url: "http://localhost:5001/app/getStats",
                                contentType: "application/json",
                                dataType: 'json',
                                success: function(stats){
                                    showStats(stats);
                                }
                            });
                        }
                    });
                }
            });

            $("#form").submit(function(e) {
                e.preventDefault();
            });

            function showResult(result) {
                $('#results').empty();  
                $('#results').append('<br />');     
                $('#results').append('<label class="description">Código ISO: </label>');   
                $('#results').append(`<label class="value">${result.country.code}</label><br /><br />`); 
                $('#results').append('<label class="description">Nombre: </label>');    
                $('#results').append(`<label class="value">${result.country.name}</label><br /><br />`); 
                $('#results').append('<label class="description">Distancia: </label>');    
                $('#results').append(`<label class="value">${Math.round(result.distance)} km</label><br /><br />`); 
                $('#results').append('<label class="description">Idiomas: </label>');  
                $('#results').append('<ul>');  
                result.country.languages.forEach((language) => { $('#results').append(`<li>${language.name}</li>`);  });
                $('#results').append('</ul><br />');  
                $('#results').append('<label class="description">Horarios: </label>');    
                $('#results').append('<ul>');  
                result.country.timeZones.forEach((timeZone) => { $('#results').append(`<li>${timeZone}</li>`);  });
                $('#results').append('</ul><br />'); 
                $('#results').append('<label class="description">Monedas: </label>');    
                $('#results').append('<ul>');  
                result.country.currencies.forEach((currency) => { $('#results').append(`<li>${currency.name} (1 ${currency.code} = ${currency.rate} USD)</li>`);  });
                $('#results').append('</ul><br />'); 
            }

            function showStats(stats) {
                $('#stats').empty();
                $('#stats').append('<br />');
                $('#stats').append('<label class="description">Distancia minima: </label>');   
                $('#stats').append(`<label class="value">${Math.round(stats.minDistance)} km</label><br /><br />`); 
                $('#stats').append('<label class="description">Distancia maxima: </label>');   
                $('#stats').append(`<label class="value">${Math.round(stats.maxDistance)} km</label><br /><br />`); 
                $('#stats').append('<label class="description">Distancia promedio: </label>');   
                $('#stats').append(`<label class="value">${Math.round(stats.avgDistance)} km</label><br /><br />`); 
            }
        </script>
    </body>
</html>